#include "stdafx.h"
#include "HSpos.h"
#include "HSposDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



CHSposDlg::CHSposDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHSposDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHSposDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_PosName, mComboPosName);
	DDX_Control(pDX, IDC_Btn_OpenClose, mBtnOpenClose);
	DDX_Control(pDX, IDC_REdit_State, mREdit_State);
}

BEGIN_MESSAGE_MAP(CHSposDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_Btn_OpenClose, &CHSposDlg::OnBnClicked_Openclose)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON2, &CHSposDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


BOOL CHSposDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);	

	bDeviceOpen=false;
	DeviceHandle=INVALID_HANDLE_VALUE;
	SetTimer(10,10,NULL);
	CString strPosName;
	for ( int i=1;i<100;i++ )
	{
		strPosName.Format(L"COM%1d",i);
		mComboPosName.AddString(strPosName);
    }
    mComboPosName.SetWindowText(L"COM4");
	return TRUE; 
}

void CHSposDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CHSposDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CHSposDlg::OnBnClicked_Openclose()
{
	if ( bDeviceOpen ){
		CloseHandle(DeviceHandle);
		mBtnOpenClose.SetWindowText(L"Open");
        mComboPosName.EnableWindow(TRUE);
		bDeviceOpen=false;
	} 
	else{
		CString strPosName;
		if (mComboPosName.GetWindowTextLength()>4)
		{
			CString s1;
			mComboPosName.GetWindowText(s1);
			strPosName=L"\\\\.\\"+s1;
		} 
		else
		{
			mComboPosName.GetWindowText(strPosName);
		}
		DeviceHandle = CreateFile(
			strPosName,
			GENERIC_READ|GENERIC_WRITE,
			NULL,
			NULL,
			OPEN_EXISTING,
			NULL,
			NULL);
        if ( DeviceHandle==INVALID_HANDLE_VALUE ){
            mComboPosName.EnableWindow(TRUE);
			return;
		}
		COMMTIMEOUTS TimeOuts;
		GetCommTimeouts(DeviceHandle,&TimeOuts);
		TimeOuts.ReadTotalTimeoutConstant=3;
		TimeOuts.ReadIntervalTimeout=0;
		TimeOuts.ReadTotalTimeoutMultiplier=0;
		TimeOuts.WriteTotalTimeoutConstant=10;
		TimeOuts.WriteTotalTimeoutMultiplier=10;
		SetCommTimeouts(DeviceHandle,&TimeOuts);
        mBtnOpenClose.SetWindowText(L"Close");
        mComboPosName.EnableWindow(FALSE);
        
        HWND hwd = NULL;
        this->GetDlgItem(IDC_BUTTON2,&hwd);
        ::SetFocus(hwd);

		bDeviceOpen=true;
	}
}

void CHSposDlg::OnClose()
{
	KillTimer(10);
	if ( bDeviceOpen ){
		CloseHandle(DeviceHandle);
	}
	CDialog::OnClose();
}
void CHSposDlg::OnOK(){
}

void CHSposDlg::OnTimer(UINT_PTR nIDEvent)
{
	if ( nIDEvent==10 )
	{
		DWORD ReceivedLen;
		char ReceiveDataBuf[2];
		if ( bDeviceOpen ){
			ReadFile(DeviceHandle,ReceiveDataBuf,1,&ReceivedLen,NULL);
			if ( ReceivedLen && ReceiveDataBuf[0] )
			{
				mREdit_State.SetWindowText(L"OPEN");
			}
			else
			{
				mREdit_State.SetWindowText(L"CLOSE");
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CHSposDlg::OnBnClickedButton2()
{
	if (bDeviceOpen)
	{
		DWORD SendedCount;
		WriteFile(DeviceHandle,"open",1,&SendedCount,NULL);
	}
}

BOOL CHSposDlg::PreTranslateMessage(MSG* pMsg){
    if(pMsg->message == WM_KEYDOWN) {        //̼µϢ

        if (pMsg->wParam == ' ')
        {
            OnBnClickedButton2();
        }
    }
    return CDialog::PreTranslateMessage(pMsg);
}